using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace CollectionPersistanceSample {
	public class CPSControl : Control {
		IntCollectionWithoutAddMethodClass icwoamc;
		IntCollectionClass col;
		IntCollectionWithAddMethodClass icwamc;
		IntCollectionWithAddRangeClass icwarc;
		CollectionWrapper wrap, cpw;
		AddCollectionWrapper acw;
		public CPSControl() {
			icwamc = new IntCollectionWithAddMethodClass();
			icwoamc = new IntCollectionWithoutAddMethodClass();
			icwarc = new IntCollectionWithAddRangeClass();
			col = new IntCollectionClass();
			wrap = new CollectionWrapper();
			cpw = new CollectionWrapper();
			acw = new AddCollectionWrapper();
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public IntCollectionWithoutAddMethodClass IntCollectionWithoutAddMethod {
			get {
				return icwoamc;
			}
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public IntCollectionWithAddRangeClass IntCollectionWithAddRange {
			get {
				return icwarc;
			}
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public IntCollectionWithAddMethodClass IntCollectionWithAddMethod {
			get {
				return icwamc;
			}
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public CollectionWrapper ContentPersistedWrapper {
			get {
				return cpw;
			}
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AddCollectionWrapper AddWrapper {
			get {
				return acw;
			}
		}
		public IntCollectionClass Collection {
			get {
				return col;
			} set {
				col = value;
			}
		}
		public CollectionWrapper Wrapper {
			get {
				return wrap;
			} set {
				wrap = value;
			}
		}
	}
	[Serializable]
	public class IntCollectionWithoutAddMethodClass : CollectionBase {
		public int this[int index] {
			get {
				return (int)List[index];
			} set {
				List[index] = value;
			}
		}
	}
	[Serializable]
	public class IntCollectionWithAddMethodClass : IntCollectionWithoutAddMethodClass {
		public int Add(int value) {
			return List.Add(value);
		}
	}
	[Serializable]
	public class IntCollectionWithAddRangeClass : IntCollectionWithAddMethodClass {
		public void AddRange(int[] value) {
			InnerList.AddRange(value);
		}
	}
	[Serializable]
	public class IntCollectionClass : CollectionBase {
		public int this[int index] {
			get {
				return (int)List[index];
			} set {
				List[index] = value;
			}
		}
		public int Add(int value) {
			return List.Add(value);
		}
	}
	[Serializable]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public class CollectionWrapper {
		IntCollectionClass col;
		public CollectionWrapper() {
			col = new IntCollectionClass();
		}
		public IntCollectionClass Collection {
			get {
				return col;
			}
		}
	}
	[Serializable]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public class AddCollectionWrapper {
		IntCollectionWithAddRangeClass col;
		public AddCollectionWrapper() {
			col = new IntCollectionWithAddRangeClass();
		}
		public IntCollectionWithAddRangeClass Collection {
			get {
				return col;
			}
		}
	}
}
