using System;
using System.Collections;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Globalization;
using System.ComponentModel;
using System.ComponentModel.Design.Serialization;
using System.Reflection;

namespace PropertyPersistedByConstructorSample {
	public class PPBCSControl : Control {
		ConstructorPersistedClass cpc;
		ConstructorPersistedStruct cps;
		public PPBCSControl() {
			cpc = new ConstructorPersistedClass(1);
			cps = new ConstructorPersistedStruct("value");
		}
		public ConstructorPersistedClass ConstructorPersistedClassProperty {
			get {
				return cpc;
			} set {
				cpc = value;
			}
		}
		public ConstructorPersistedStruct ConstructorPersistedStructProperty {
			get {
				return cps;
			} set {
				cps = value;
			}
		}
	}
	[Serializable]
	[TypeConverter(typeof(ConstructorPersistedClass._ConstructorPersistedClassConverter))]
	public class ConstructorPersistedClass {
		internal class _ConstructorPersistedClassConverter : ExpandableObjectConverter {
			public override bool CanConvertTo(ITypeDescriptorContext context, Type dst_type) {
				if (dst_type == typeof(InstanceDescriptor))
					return true;
				return base.CanConvertTo(context, dst_type);
			}
			public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type dst_type) {
				if (dst_type == typeof(InstanceDescriptor)) {
					ConstructorPersistedClass cpc = value as ConstructorPersistedClass;
					ConstructorInfo ci = typeof(ConstructorPersistedClass).GetConstructor(new Type[]{typeof(int)});
					return new InstanceDescriptor(ci, new object[]{cpc.Data});
				}
				return base.ConvertTo(context, culture, value, dst_type);
			}
		}
		int data;
		public ConstructorPersistedClass(int data) {
			this.data = data;
		}
		public int Data {
			get {
				return data;
			} set {
				data = value;
			}
		}
	}
	[Serializable]
	[TypeConverter(typeof(ConstructorPersistedStruct._ConstructorPersistedStructConverter))]
	public struct ConstructorPersistedStruct {
		internal class _ConstructorPersistedStructConverter : ExpandableObjectConverter {
			public override bool CanConvertTo(ITypeDescriptorContext context, Type dst_type) {
				if (dst_type == typeof(InstanceDescriptor))
					return true;
				return base.CanConvertTo(context, dst_type);
			}
			public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type dst_type) {
				if (dst_type == typeof(InstanceDescriptor)) {
					ConstructorInfo ci = typeof(ConstructorPersistedStruct).GetConstructor(new Type[]{typeof(string)});
					string s = ((ConstructorPersistedStruct)value).Data;
					return new InstanceDescriptor(ci, new object[]{s});
				}
				return base.ConvertTo(context, culture, value, dst_type);
			}
		}
		string data;
		public ConstructorPersistedStruct(string data) {
			this.data = data;
		}
		public string Data {
			get {
				return data;
			} set {
				data = value;
			}
		}
	}
}
